/***********************************************
*  t\탉Cu
*  I2CC^[tF[X
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(data) ----- P\o
*    lcd_str(ptr)  ----- \o
*    lcd_clear()   ----- S
**********************************************/
#include <xc.h>
#include "lcd_i2c_lib24.h"
/********************************
*  p萔
*********************************/
//#define CONTRAST	0x20            // for 5.0V
#define CONTRAST  0x30		// for 3.3V
/*********************************
*@ACR̒`
*********************************/
const unsigned char Mark[14][2]={
	{0x00, 0x10},		// Aei
	{0x02, 0x10},		// db
	{0x04, 0x10},		// 
	{0x06, 0x10},		// WbN
	{0x07, 0x10},		// 
	{0x07, 0x08},		// 
	{0x07, 0x18},		// 
	{0x09, 0x10},		// 
	{0x0B, 0x10},		// s
	{0x0D, 0x02},		// dr
	{0x0D, 0x12},		// eʏ
	{0x0D, 0x1A},		// eʒ
	{0x0D, 0x1E},		// eʑ
	{0x0F, 0x10}		// 
};
/***************************************************************
* I2CoXLCDR}hM
****************************************************************/
void lcd_cmd(char cmd)
{
//    SRbits.IPL = 7;                             // 荞݂֎~
    IdleI2C1();                                 // AChmF
    I2C1CONbits.SEN = 1;   			// X^[go//
    while(I2C1CONbits.SEN);			// X^[gI҂//
    SendByte(0x7C);				// AhXM//
    SendByte(0x00);				// R}hw著M//
    SendByte(cmd);				// R}hM//
    I2C1CONbits.PEN = 1;   			// Xgbvo//
    while(I2C1CONbits.PEN);			// XgbvI҂//
    /* ClearHomȇ҂Ԕ*/
    if((cmd == 0x01) || (cmd == 0x02))          // R}hʔ
        Delayms(2);                             // 2msec
    else
        Delayus(30);                            // ʃR}h̏ꍇ
//    SRbits.IPL = 2;                             // 荞ݍċ
}
/***************************************************************
* I2CoXLCD\f[^M
****************************************************************/
void lcd_data(char data)
{
//    SRbits.IPL = 7;                             // 荞݂֎~
    IdleI2C1();                                 // AChmF
    I2C1CONbits.SEN = 1;   			// X^[go//
    while(I2C1CONbits.SEN);			// X^[gI҂//
    SendByte(0x7C);				// AhXM//
    SendByte(0x40);				// \f[^w著M//
    SendByte(data);				// R}hM//
    I2C1CONbits.PEN = 1;   			// Xgbvo//
    while(I2C1CONbits.PEN);			// XgbvI҂//
    Delayus(30);                                // I҂
//    SRbits.IPL = 2;                             // 荞ݍċ
}
/****************************
 *  1oCgM֐
 ****************************/
void SendByte(unsigned char data){
    IFS1bits.MI2C1IF = 0;
    I2C1TRN = data;				// f[^M//
    while(IFS1bits.MI2C1IF == 0);                // MI҂//
}
/** ACh҂Tu֐@***/
void IdleI2C1(void){
    /* Wait until I2C Bus is Inactive */
    while(I2C1CONbits.SEN || I2C1CONbits.PEN || I2C1CONbits.RCEN
    		 || I2C1CONbits.ACKEN || I2C1STATbits.TBF || I2C1STATbits.RBF);
}
/***********************************************
* ^C}4ɂ1msecPʂ̒x֐ Fcy=16MHz
***********************************************/
void Delayms( unsigned int t){
    IFS1bits.T4IF = 0;                  // 荞݃tONA
    PR4 = 16000;                        // 1msecݒ
    T4CON = 0x8000;                     // ^C}4X^[g@vXP[ 1/1
    while (t--) {                       // JԂ
        while (!IFS1bits.T4IF);         // 1msec҂
        IFS1bits.T4IF = 0;              // 荞݃tONA
    }
}
void Delayus(unsigned int t)
{
    long l;
    for(l=0; l<140; l++);
}
/*******************************
*  ֐
*******************************/
void lcd_init(void)
{
    Delayms(100);
    lcd_cmd(0x38);				// 8bit 2line Normal mode
    lcd_cmd(0x39);				// 8bit 2line Extend mode
    lcd_cmd(0x14);				// OSC 183Hz BIAS 1/5
    /* RgXgݒ */
    lcd_cmd(0x70 + (CONTRAST & 0x0F));
    lcd_cmd(0x5C + (CONTRAST >> 4));
//    lcd_cmd(0x6A);				// Follower for 5.0V
    lcd_cmd(0x6B);				// Ffollwer for 3.3V
    Delayms(300);
    lcd_cmd(0x38);				// Set Normal mode
    lcd_cmd(0x0C);				// Display On
    lcd_cmd(0x01);				// Clear Display
}
/******************************
* S֐
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);				//R}ho
}
/*****************************
* \֐
*****************************/
void lcd_str(char* ptr)
{
    while(*ptr != 0)				//o
        lcd_data(*ptr++);			//\
}
/*****************************
*  ACR\֐
*****************************/
void lcd_icon(unsigned char num, unsigned char onoff)
{
    lcd_cmd(0x39);				// Extend mode
    lcd_cmd(0x40 | Mark[num][0]);               // ACRAhXw
    if(onoff)
        lcd_data(Mark[num][1]);                 // ACRIf[^
    else
        lcd_data(0x00);                         // ACRItf[^
    lcd_cmd(0x38);				// Normal Mode
}

