#!/usr/bin/python
#-*- coding:utf-8 -*-
#******************************************************************
#  デジタルマルチメータ　データをブラウザに渡す関数群
#　データ収集のPython関数（DMM01.py)を実行する
#******************************************************************
from time import sleep
import datetime
import time
import locale
import webiopi
import serial
import subprocess as proc

#ディレクトリ指定
logpath = '/home/pi/DMM/'
logfile = 'logdata.log'

Value = 0		#テスト用

#***** データ表示関数 *******
@webiopi.macro
def GetValue(item):
	global Value, data
	dates = []
	Volt = []
	Current = []
	Capacitor = []
	RegisterM = []
	RegisterK = []
	Frequency = []

	#ファイルからデータの読み出し
	f = open(logpath + logfile, 'r')
	#読み出したリストからデータ取り出し
	for line in f:
		dates.append(datetime.datetime.strptime(line[0:5], "%H%M%S"))
		Volt.append(str(line[8:15]))
		Current.append(str(line[16:22]))
		Capacitor.append(int(line[23:30]))
		RegisterM.append(int(line[31:35]))
		RegisterK.append(int(line[38:43]))
		Frequency.append(int(line[44:52]))
	f.close()
	#指定された計測値を返す
	if('0' == item):
		return "%s" % Volt[0]
	elif('1' == item):
		return "%s" % Current[0]
	elif('2' == item):
		return "%d" % Capacitor[0]
	elif('3' == item):
		return "%d" % RegisterM[0]
	elif('4' == item):
		return "%d" % RegisterK[0]
	elif('5' == item):
		return "%d" % Frequency[0]
	else:
		Value = Value+1		#テスト用
		return "%d" % Value
#******  トリガ *******
@webiopi.macro
def Trigger():
	proc.call("sudo killall sudo", shell=True)
	proc.call("sudo python /home/pi/DMM/DMM01.py &", shell=True)

#***** シャットダウン実行関数 *******
@webiopi.macro
def ShutCmd():
	proc.call("sudo killall sudo", shell=True)
	proc.call("sudo /sbin/shutdown -h now", shell=True)	
